/*
	FreeRTOS V5.4.1 - Copyright (C) 2009 Real Time Engineers Ltd.

	This file is part of the FreeRTOS distribution.

	FreeRTOS is free software; you can redistribute it and/or modify it	under 
	the terms of the GNU General Public License (version 2) as published by the 
	Free Software Foundation and modified by the FreeRTOS exception.
	**NOTE** The exception to the GPL is included to allow you to distribute a
	combined work that includes FreeRTOS without being obliged to provide the 
	source code for proprietary components outside of the FreeRTOS kernel.  
	Alternative commercial license and support terms are also available upon 
	request.  See the licensing section of http://www.FreeRTOS.org for full 
	license details.

	FreeRTOS is distributed in the hope that it will be useful,	but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along
	with FreeRTOS; if not, write to the Free Software Foundation, Inc., 59
	Temple Place, Suite 330, Boston, MA  02111-1307  USA.


	***************************************************************************
	*                                                                         *
	* Looking for a quick start?  Then check out the FreeRTOS eBook!          *
	* See http://www.FreeRTOS.org/Documentation for details                   *
	*                                                                         *
	***************************************************************************

	1 tab == 4 spaces!

	Please ensure to read the configuration and relevant port sections of the
	online documentation.

	http://www.FreeRTOS.org - Documentation, latest information, license and
	contact details.

	http://www.SafeRTOS.com - A version that is certified for use in safety
	critical systems.

	http://www.OpenRTOS.com - Commercial support, development, porting,
	licensing and training services.
*/

/* FreeRTOS.org includes. */
#include "FreeRTOS.h"

/* Demo application includes. */
#include "partest.h"

#define partstFIRST_IO			( ( unsigned portLONG ) 0x01 )
#define partstNUM_LEDS			( 2 )
#define partstALL_OUTPUTS_OFF	( ( unsigned portLONG ) 0xff )

// Pin I/O LED Control Maskbit
#define  LED1       0x02000000   							// P3.25(0000 00x0 0000 0000 0000 0000 0000 0000)
#define  LED2       0x04000000   							// P3.26(0000 0x00 0000 0000 0000 0000 0000 0000)

#define  LED1_ON()  FIO3CLR = LED1    						// LED1 Pin = 0 (ON LED)
#define  LED1_OFF() FIO3SET = LED1							// LED1 Pin = 1 (OFF LED)
#define  LED2_ON()  FIO3CLR = LED2							// LED2 Pin = 0 (ON LED)
#define  LED2_OFF() FIO3SET = LED2							// LED2 Pin = 1 (OFF LED)

int led_1_state;
int led_2_state;


/*-----------------------------------------------------------
 * Simple parallel port IO routines.
 *-----------------------------------------------------------*/

void vParTestInitialise( void )
{

 // Config Pin GPIO3[26:25]   
  PINSEL7  &= 0xFFC3FFFF;  									// P3[26:25] = GPIO Function(xxxx xxxx xx00 00xx xxxx xxxx xxxx xxxx)
  PINMODE7 &= 0xFFC3FFFF;									// Enable Puul-Up on P3[26:25]
   
  FIO3DIR  |= LED1;  						         		// Set GPIO-3[26:25] = Output(xxxx x11x xxxx xxxx xxxx xxxx xxxx xxxx)
  FIO3DIR  |= LED2;
  LED1_OFF();												// Default LED Status
  LED2_OFF();

//	PINSEL10 = 0;
//	FIO2DIR  = 0x000000FF;
//	FIO2MASK = 0x00000000;
//	FIO2CLR  = 0xFF;
//	SCS |= (1<<0); //fast mode for port 0 and 1

//    FIO2CLR = partstALL_OUTPUTS_OFF;
}
/*-----------------------------------------------------------*/

void vParTestSetLED( unsigned portBASE_TYPE uxLED, signed portBASE_TYPE xValue )
{
unsigned portLONG ulLED = partstFIRST_IO;
#if 0
	if( uxLED < partstNUM_LEDS )
	{
		/* Rotate to the wanted bit of port */
		ulLED <<= ( unsigned portLONG ) uxLED;

		/* Set of clear the output. */
		if( xValue )
		{
			FIO2CLR = ulLED;
		}
		else
		{
			FIO2SET = ulLED;
		}
	}
#endif
}
/*-----------------------------------------------------------*/

void vParTestToggleLED( unsigned portBASE_TYPE uxLED )
{
unsigned portLONG ulLED = partstFIRST_IO, ulCurrentState;


    if (led_1_state == 0)
    {
      LED1_ON();

      led_1_state = 1;
    } 
      else 
    {
      LED1_OFF();
      led_1_state = 0;
    }


#if 0
	if( uxLED < partstNUM_LEDS )
	{
		/* Rotate to the wanted bit of port 0.  Only P10 to P13 have an LED
		attached. */
		ulLED <<= ( unsigned portLONG ) uxLED;

		/* If this bit is already set, clear it, and visa versa. */
		ulCurrentState = FIO2PIN;
		if( ulCurrentState & ulLED )
		{
			FIO2CLR = ulLED;
		}
		else
		{
			FIO2SET = ulLED;			
		}
	}	
#endif
}

/*-----------------------------------------------------------*/
unsigned portBASE_TYPE uxParTextGetLED( unsigned portBASE_TYPE uxLED )
{
#if 0
unsigned portLONG ulLED = partstFIRST_IO;
    
    ulLED <<= ( unsigned portLONG ) uxLED;

    return ( FIO2PIN & ulLED );
#endif
	return 0;
}


